/*------------------------------------------------------------------------------*
 * File Name:	AscImpOptions.h													*
 * Creation: 																	*
 * Purpose: OriginC Source C file												*
 * Copyright (c) ABCD Corp.	2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010		*
 * All Rights Reserved															*
 * 																				*
 * Modification Log:															*
 *	Hong 03/02/07 QA-9418 ADD_REPEAT_IMPORT										*
 *	Sim 05-24-2007 SUPPORT_CONVERT_OPTIONS_TO_FILTER							*
 *	Folger 09/29/09 QA80-14392 IMPASC_FAILS_TO_IMPORT_NUMERIC_DATA_ON_GOS_WITH_DEFAULT_OPTIONS
 *	Hong 03/11/10 QA80-15192 SUPPORT_EDIT_BINARY_FILTER_CREATED_BY_IMPWIZ		*
 *------------------------------------------------------------------------------*/

 
#ifndef ASCIMP_OPTIONS
#define ASCIMP_OPTIONS

void construct_ascii_import_options(TreeNode& trGetN, bool bAddUpdateButton = true);

bool GetNTreeToASCIMP(ASCIMP& aiTarget, TreeNode& trnSource);
bool ASCIMPToGetNTree(TreeNode& trnTarget, ASCIMP& aiSource);
/// Hong 03/02/07 QA-9418 ADD_REPEAT_IMPORT
//bool FilterToOptions(const TreeNode& trFilter, TreeNode& trOptions); ///---Sim 09-27-2006 SUPPORT_CONVERT_FILTER_TO_OPTIONS
bool FilterToOptions(const TreeNode& trFilter, TreeNode& trOptions, BOOL bReimport = false); ///---Sim 09-27-2006 SUPPORT_CONVERT_FILTER_TO_OPTIONS
/// end ADD_REPEAT_IMPORT
///---Sim 05-24-2007 SUPPORT_CONVERT_OPTIONS_TO_FILTER
bool OptionsToFilter(const TreeNode& trOptions, TreeNode& trFilter);
///---END SUPPORT_CONVERT_OPTIONS_TO_FILTER

/// Hong 03/11/10 QA80-15192 SUPPORT_EDIT_BINARY_FILTER_CREATED_BY_IMPWIZ
void construct_binary_import_options(TreeNode& trGetN);
bool BinaryFilterToOptions(const TreeNode& trFilter, TreeNode& trOptions);
bool BinaryOptionsToFilter(const TreeNode& trOptions, TreeNode& trFilter, bool bReintBINIMP = false);
/// end SUPPORT_EDIT_BINARY_FILTER_CREATED_BY_IMPWIZ

///------ Folger 09/29/09 QA80-14392 IMPASC_FAILS_TO_IMPORT_NUMERIC_DATA_ON_GOS_WITH_DEFAULT_OPTIONS
int		check_get_numeric_separator_from_file(LPCSTR lpcszFile);
///------ End IMPASC_FAILS_TO_IMPORT_NUMERIC_DATA_ON_GOS_WITH_DEFAULT_OPTIONS

#endif  // ASCIMP_OPTIONS