/*------------------------------------------------------------------------------*
 * File Name: ImpWizUserDefined.h												*
 * Creation: Jason 12/12/2003													*
 * Purpose: Origin C file containing Application Utilities						*
 * Copyright (c) OriginLab Corp.	2002-2007									*
 * All Rights Reserved															*
 * 																				*
 * Modification Log:															*
 *	 Jason 12/12/03 v7.5780 MOVE_TO_INIT_USERDEFINED							*
 *	 Jason 12/12/03 v7.5780 MOVED_INIT_FUNCTION									*
 *	 Jason 12/19/03 v7.5781 ADD_SOME_MACRO										*
 *   Danice 3/1/04 v8.0828 PAGE_INIT_ONCE										*
 * EJP 08-13-2004 v8.0117 QA70-6472 IMPORT_INFO_STORAGE_CLEANUP					*
 * EJP 2005-08-22 v8.0292 QA70-7996 IMPWIZ_SUPPORT_XFUNC						*
 * EJP 2007-02-26 v8.0571 REMOVE_OC_CLASS_SUPPORT_FROM_IMPWIZ					*
 *------------------------------------------------------------------------------*/

#define ON_PAGE_CHECK_USER_DEFINED			if(!IS_SHOW_USER_DEFINED_PAGE) return FALSE;

// Derived WizPage class for WizPage1
class ImpWizUserDefinedPage : public ImpWizardPage
{
	// Constructor for ImpWizUserDefinedPage class, use parent constructor
	//ImpWizUserDefinedPage(int nID) : ImpWizardPage(nID) {}
	
public:
	
	EVENTS_BEGIN
		//PAGE_ON_IS_SHOW(OnIsShow_UserDefined)		///Danice 12/25/03 v7.5788 NOTUSE_SHOW
		PAGE_ON_INIT(OnInit_UserDefined)
		PAGE_ON_ACTIVE(OnActive_UserDefined)
		PAGE_ON_KILLACTIVE(OnKillActive_UserDefined)
		
		ON_BN_CLICKED(IDC_USER_DEFINED_BROWSE, OnClickBrowse_UserDefined)

		/// EJP 2007-02-26 v8.0571 REMOVE_OC_CLASS_SUPPORT_FROM_IMPWIZ
		///// EJP 08-13-2004 v8.0117 QA70-6472 IMPORT_INFO_STORAGE_CLEANUP
		//ON_BN_CLICKED(IDC_USE_OC_CLASS, OnClickUseClass)
		//ON_BN_CLICKED(IDC_USE_OC_FUNC, OnClickUseFunc)
		///// end IMPORT_INFO_STORAGE_CLEANUP
		/// end REMOVE_OC_CLASS_SUPPORT_FROM_IMPWIZ
	EVENTS_END

	//Events handles
	
	///Danice 12/25/03 v7.5788 NOTUSE_SHOW
	/*
	//--------------------------------------------------------------------------
	// OnIsShowUserDefined
	//
	// ON_PAGE_IS_SHOW handler function for all User Defined pages.
	//--------------------------------------------------------------------------
	BOOL OnIsShow_UserDefined(DWORD dwPageID, DWORD lParam);	///Jason 12/12/03 v7.5780 CHANGE_SOME_FUNCTION_NAME
	*/
	DWORD    OnShowStatus(DWORD InternalStatus);
	///END NOTUSE_SHOW

	BOOL OnInit_UserDefined();			///Jason 12/12/03 v7.5780 CHANGE_SOME_FUNCTION_NAME

	BOOL OnActive_UserDefined();			///Jason 12/12/03 v7.5780 CHANGE_SOME_FUNCTION_NAME

	BOOL OnKillActive_UserDefined();		///Jason 12/12/03 v7.5780 CHANGE_SOME_FUNCTION_NAME
	
	BOOL OnClickBrowse_UserDefined(Control ctrl);	///Jason 12/12/03 v7.5780 CHANGE_SOME_FUNCTION_NAME

	/// EJP 2007-02-26 v8.0571 REMOVE_OC_CLASS_SUPPORT_FROM_IMPWIZ
	///// EJP 08-13-2004 v8.0117 QA70-6472 IMPORT_INFO_STORAGE_CLEANUP
	//BOOL OnClickUseClass(Control ctrl);
	//BOOL OnClickUseFunc(Control ctrl);
	//void UpdateEditEnable();
	///// end IMPORT_INFO_STORAGE_CLEANUP
	/// end REMOVE_OC_CLASS_SUPPORT_FROM_IMPWIZ

	BOOL UserDefined_Update(BOOL bTreeToDlg=TRUE);	
	
private:
	
	Edit m_editPath;
	Edit m_editFunc;
	
	/// EJP 2007-02-26 v8.0571 REMOVE_OC_CLASS_SUPPORT_FROM_IMPWIZ
	///// EJP 08-13-2004 v8.0117 QA70-6472 IMPORT_INFO_STORAGE_CLEANUP
	//Edit m_ebClass;
	///// end IMPORT_INFO_STORAGE_CLEANUP
	/// end REMOVE_OC_CLASS_SUPPORT_FROM_IMPWIZ
};

/// EJP 2005-08-22 v8.0292 QA70-7996 IMPWIZ_SUPPORT_XFUNC
class ImpWizXFuncOptionsPage : public ImpWizardPage
{
public:
	
	EVENTS_BEGIN
		PAGE_ON_INIT(OnInit)
		PAGE_ON_ACTIVE(OnActive)
		PAGE_ON_KILLACTIVE(OnKillActive)
	EVENTS_END
	
	BOOL OnInit();
	BOOL OnActive();
	BOOL OnKillActive();

	DWORD OnShowStatus(DWORD InternalStatus);
};
/// end IMPWIZ_SUPPORT_XFUNC
