/*------------------------------------------------------------------------------*
 * File Name: stats_guis2.c														*
 * Creation: GJL 12/30/03 														*
 * Purpose: OriginC Source C file implementing Origin Statistics GUIs.			*
 * Copyright (c) OriginLab Corp.	2003, 2004, 2005, 2006, 2007, 2008			*
 * All Rights Reserved															*
 * 																				*
 * Modification Log:															*
 *------------------------------------------------------------------------------*/
 
#include <Origin.h>
#include <GetNBox.h>

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////               Pearson r Correlation Coefficient              //////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

//void GetPearsonRCorrelationCoefParams()
//{
////	string strSelectionRange = GetSingleColumnWksSelection();
//
	//GETN_TREE(tr)
//
	//GETN_BUTTON(Sample1, "Sample1", "Data1_B[1]:B[30]"); // strSelectionRange)
	//GETN_BUTTON(Sample2, "Sample2", "Data1_C[1]:C[30]"); // strSelectionRange)
//
	//GetNBox(tr, "Pearson r Correlation Coefficient", "Enter Pearson r Correlation Coefficient parameters", ApplyOnClickPro); //, DialogOnChangeEvent);
//}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////                      Mann-Whitney U-Test                     //////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

//void GetMannWhitneyUTestParams()
//{
////	string strSelectionRange = GetSingleColumnWksSelection();
//
	//GETN_TREE(tr)
			//
	//GETN_BUTTON(Sample1, "Sample1 from F(x)", "Data1_B[1]:B[30]"); // strSelectionRange)
	//GETN_BUTTON(Sample2, "Sample2 from G(y)", "Data1_C[1]:C[30]"); // strSelectionRange)
//
	//GETN_BEGIN_BRANCH(Hypotheses, "Hypotheses")
		//GETN_OPTION_BRANCH(GETNBRANCH_OPEN)
		//GETN_STR(Null,"Null:", "F(x) <> G(y)")
		//GETN_LIST(Alternate, "Alternate:", 1, "F(x) <> G(y)|F(x)  > G(y)|F(x)  < G(y)")
		//GETN_NUM(SigLevel, "Significance Level", 0.05)
	//GETN_END_BRANCH(Hypotheses)
//
	//GETN_BEGIN_BRANCH(SampleSizes, "Sample Sizes")
		//GETN_OPTION_BRANCH(GETNBRANCH_OPEN)
		//GETN_NUM(Sample1, "Sample1 from F(x)", 30)
		//GETN_NUM(Sample2, "Sample2 from G(y)", 25)
		//GETN_CHECK(Approximate, "Approximate P Value", false)
	//GETN_END_BRANCH(SampleSizes)
//
	//GetNBox(tr, "Mann-Whitney U-Test", "Enter Mann-Whitney U-Test parameters", ApplyOnClickPro); //, DialogOnChangeEvent);
//}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////                   Wilcoxon Signed Rank Test                  //////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

//void GetWilcoxonSignedRankTestParams()
//{
////	string strSelectionRange = GetSingleColumnWksSelection();
//
	//GETN_TREE(tr)
			//
	//GETN_BUTTON(Sample1, "Sample1", "Data1_B[1]:B[30]"); // strSelectionRange)
	//GETN_BUTTON(Sample2, "Sample2", "Data1_C[1]:C[30]"); // strSelectionRange)
//
	//GETN_BEGIN_BRANCH(Hypotheses, "Hypotheses")
		//GETN_OPTION_BRANCH(GETNBRANCH_OPEN)
		//GETN_NUM(Null,"Null: Median1 - Median2 = ", 0)
		//GETN_LIST(Alternate, "Alternate: Median1 - Median2", 1, "<> 0|> 0|< 0")
		//GETN_NUM(SigLevel, "Significance Level", 0.05)
	//GETN_END_BRANCH(Hypotheses)
//
	//GETN_CHECK(Zeros, "Include zeros when ranking", false)
//
	//GetNBox(tr, "Wilcoxon Signed Rank Test", "Enter Wilcoxon Signed Rank Test parameters", ApplyOnClickPro); //, DialogOnChangeEvent);
//}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////                    Repeated Measure ANOVA                    //////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

//void GetRepeatedMeasureANOVAParams()
//{
	//GETN_TREE(tr)
//
	//GETN_BUTTON(Measurements, "Measurements", "Data1_A[1]:C[30]");
//
	//GETN_NUM(SigLevel, "Significance Level", 0.05)
//
	//GETN_BEGIN_BRANCH(MeansComp, "Means Comparison")
		//GETN_OPTION_BRANCH(GETNBRANCH_OPEN)
		//GETN_CHECK(Bonferroni, "Bonferroni", false)
		//GETN_CHECK(Scheffe, "Scheffe'", false)
		//GETN_CHECK(Tukey, "Tukey", false)
	//GETN_END_BRANCH(MeansComp)
//
	//GETN_BEGIN_BRANCH(EqualVar, "Tests for Equal Variance")
		//GETN_OPTION_BRANCH(GETNBRANCH_OPEN)
		//GETN_CHECK(Levene, "Levene", false)
		//GETN_CHECK(BrownForsythe, "Brown-Forsythe", false)
	//GETN_END_BRANCH(EqualVar)
//
	//GETN_BEGIN_BRANCH(Power, "Power Analysis")
		//GETN_OPTION_BRANCH(GETNBRANCH_OPEN)
		//GETN_CHECK(Power, "Power Analysis", false)
		//GETN_NUM(SigLevel, "Significace Level", 0.05)
		//GETN_STR(SampleSizes, "Sample Size(s)","50 100 200")
	//GETN_END_BRANCH(Power)
//
	//GetNBox(tr, "Repeated Measure ANOVA", "Enter Repeated Measure ANOVA parameters", ApplyOnClickPro);
//}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////                   Weibull Survival Analysis                  //////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

//void GetWeibullSurvivalAnalysisParams()
//{
////	string strSelectionRange = GetSingleColumnWksSelection();
//
	//GETN_TREE(tr)
//
	//GETN_BUTTON(TimeVar, "Time Variable", "Data1_B[1]:B[30]"); // strSelectionRange)
	//GETN_BUTTON(CensorVar, "Censor Variable", "Data1_C[1]:C[30]"); // strSelectionRange)
	//GETN_BUTTON(GroupVars, "Grouping Variable(s)", "Data1_D[1]:D[30]"); // strSelectionRange)
//
	//GETN_NUM(CensorVal,"Censor Value", 0)
//
	//GETN_NUM(ConfLevel,"Confidence Level", 0.95)
//
	//GETN_BEGIN_BRANCH(Results, "Survival Plot")
		//GETN_OPTION_BRANCH(GETNBRANCH_OPEN)
		//GETN_CHECK(SurvivalPlot, "Survival Plot", true)
		//GETN_CHECK(Errors, "Plot Errors", true)
		//GETN_CHECK(AsBars, "As Error Bars", false)
		//GETN_CHECK(CensoredPoints, "Indicate Censored Points", false)
		//GETN_CHECK(FailurePoints, "Indicate Failure Points", false)
		//GETN_CHECK(PercentageScale, "Use Percentage Scale", false)
	//GETN_END_BRANCH(Results)
//
	//GetNBox(tr, "Weibull Survival Analysis", "Enter Weibull Survival Analysis parameters", ApplyOnClickPro); //, DialogOnChangeEvent);
//}
//
//bool ApplyOnClickPro(TreeNode& tr)
//{
	//out_str("\n-----from inside function ApplyOnClick");
	//out_tree(tr);
	//out_str("-----exit from ApplyOnClick\n");
	//return false;
//}