/*------------------------------------------------------------------------------*
 * File Name: xfdynadlg_utils.h			 										*
 * Purpose: Declare functions that are related to XFDynaDlg						*
 * Copyright (c)2003 OriginLab Corp.											*
 * All Rights Reserved															*
 *																				*
 *	Modification Log:															*
 *	Sim 03-14-2008 ALLOW_DESTROY_ATTACHED_PAGE									*
 *	Folger 12/11/08 QA80-12764 v8.0985 MODIFY_PEAKS_IN_PA_DURING_CHANGE_PARAMETER_MAKE_ORIGIN_LOCK
 *------------------------------------------------------------------------------*/
 
#ifndef __XFDYNADLG_UTILS_H__
#define __XFDYNADLG_UTILS_H__

enum
{
	WIZ_PFM	= 0,
	WIZ_SPFM,
	WIZ_BP,
	WIZ_PAW, // Sandy 2008-2-4  add for test new design of Wizard
};

bool	xf_dynadlg_storage_control(Page &pg, LPCSTR lpcszNodeName, int &nVal, bool bGet = true);
bool	xf_dynadlg_hwnd_control(Page &pg, int &nHwnd, bool bGet = true);
//------ Folger 12/11/08 QA80-12764 v8.0985 MODIFY_PEAKS_IN_PA_DURING_CHANGE_PARAMETER_MAKE_ORIGIN_LOCK
//bool	xf_dynadlg_shown_control(Page &pg, int &nShow, bool bGet = true);
bool	xf_dynadlg_shown_control(Page &pg, int &nShow, bool bGet = true, bool bMinimizedBeforeHidden = false);
//------ End MODIFY_PEAKS_IN_PA_DURING_CHANGE_PARAMETER_MAKE_ORIGIN_LOCK
bool	xf_dynadlg_redraw_control(Page &pg, int &nRedraw, bool bGet = true);
///---Sim 12-18-2007 SPECIFY_ACTIVE_PAGE_AFTER_XF_WIZ_FINISH
bool	xf_dynadlg_send_msg(Page &pg, uint msg, DWORD wParam = 0, DWORD lParam = 0);
/// YuI 04/02/08 WORK_ON_PA
bool	xf_dynadlg_post_msg(Page &pg, uint msg, DWORD wParam = 0, DWORD lParam = 0);
/// end WORK_ON_PA
///---END SPECIFY_ACTIVE_PAGE_AFTER_XF_WIZ_FINISH

bool	check_xf_dynadlg_open(Page &pg);
///---Sim 03-14-2008 ALLOW_DESTROY_ATTACHED_PAGE
//bool	open_xf_wizard_dlg(LPCSTR lpcszFuncNameCreatClass, LPCSTR lpcszFuncFileCreatClass, bool bScriptMode = false, LPCSTR lpcszDefaultThemeName = NULL);
////bool	open_xf_wizard_dlg(int nWizardDlgType);
//bool	open_xf_wizard_dlg(int nWizardDlgType, bool bScriptMode = false, LPCSTR lpcszDefaultThemeName = NULL);
bool	open_xf_wizard_dlg(LPCSTR lpcszFuncNameCreatClass, LPCSTR lpcszFuncFileCreatClass, bool bScriptMode = false, LPCSTR lpcszDefaultThemeName = NULL, bool bDestroyPageOnClose = false);
bool	open_xf_wizard_dlg(int nWizardDlgType, bool bScriptMode = false, LPCSTR lpcszDefaultThemeName = NULL, bool bDestroyPageOnClose = false);
///---END ALLOW_DESTROY_ATTACHED_PAGE
bool	open_xf_independent_dlg(LPCSTR lpcszXFName);

#endif //__XFDYNADLG_UTILS_H__
