/*------------------------------------------------------------------------------*
 * File Name: OC_NAG.h															*
 * Creation: CPY 5/15/2001														*
 * Purpose: Origin C Header for NAG functions									*
 * Copyright (c) OriginLab Corp.	2001										*
 * All Rights Reserved															*
 * 																				*
 * Modification Log:															*
 * GJL 1/29/04 Exclude unneeded NAG header files in Origin 8.0					*
 *	Cheney 2007-6-5 INCLUDE_OTHER_NAG_HEADER_FILES								*
 *	Cheney 2007-7-5 QA70-9870 SUPPORT_FUNC_POINTER_NOW							*
 *	Echo 2008/3/4 ADD_MISSING_NAG_CAT											*
 *------------------------------------------------------------------------------*/

#pragma PCH	//CPY 12/7/04
#include <origin.h>

#ifndef _O_NAG8_H
#define _O_NAG8_H

#pragma message("NAG8 is included")

#include	<NAG8\nag.h>
#include	<NAG8\nags.h>
#include	<NAG8\nagg01.h>
#include	<NAG8\nagg02.h>
#include	<NAG8\nagg04.h>
#include	<NAG8\nagg07.h> ///Echo 9/19/05
#include	<NAG8\nagg08.h>
#include	<NAG8\nagg12.h>

#include	<NAG8\nage01.h>	///Leo 06/17/05
#include	<NAG8\nage02.h>	///Leo 06/13/05 

//Cheney 2007-6-5 INCLUDE_OTHER_NAG_HEADER_FILES
#include	<NAG8\naga00.h>
#include	<NAG8\naga02.h>

#include	<NAG8\nagc02.h>
#include	<NAG8\nagc05.h>
#include	<NAG8\nagc06.h>

//#ifdef NAG_FUNC_POINTER
//#include	<NAG8\nagd01.h>
//#include	<NAG8\nagd02.h>
//#include	<NAG8\nagd03.h>
//#include	<NAG8\nagd06.h>
//
//#include	<NAG8\nage04.h>
//#endif //NAG_FUNC_POINTER
///Cheney 2007-7-5 QA70-9870 SUPPORT_FUNC_POINTER_NOW
#include	<NAG8\nagd01.h>
#include	<NAG8\nagd02.h>
#include	<NAG8\nagd03.h>
#include	<NAG8\nagd06.h>

#include	<NAG8\nage04.h>
///end SUPPORT_FUNC_POINTER_NOW

#include	<NAG8\nagf01.h>
#include	<NAG8\nagf02.h>
#include	<NAG8\nagf03.h>
#include	<NAG8\nagf04.h> ///Echo 2008/3/4 ADD_MISSING_NAG_CAT
#include	<NAG8\nagf06.h>
#include	<NAG8\nagf07.h>
#include	<NAG8\nagf08.h>
#include	<NAG8\nagf11.h>
#include	<NAG8\nagf16.h>

#include	<NAG8\nagg03.h>
//#ifdef NAG_TWO_DIMS_ARRAY
//#include	<NAG8\nagg05.h>
//#endif //NAG_TWO_DIMS_ARRAY
#include	<NAG8\nagg10.h>
#include	<NAG8\nagg11.h>
#include	<NAG8\nagg13.h>

//#ifdef NAG_FUNC_POINTER
//#include	<NAG8\nagh02.h>
//#endif //NAG_FUNC_POINTER
#include	<NAG8\nagh02.h> ///Cheney 2007-7-5 QA70-9870 SUPPORT_FUNC_POINTER_NOW
#include	<NAG8\nagh03.h>

//#ifdef NAG_FUNC_POINTER
//#include	<NAG8\nagm01.h>
//#endif //NAG_FUNC_POINTER
#include	<NAG8\nagm01.h> ///Cheney 2007-7-5 QA70-9870 SUPPORT_FUNC_POINTER_NOW

#include	<NAG8\nagp01.h>

#include	<NAG8\nagx01.h>
#include	<NAG8\nagx02.h>
#include	<NAG8\nagx03.h>
#include	<NAG8\nagx04.h>
#include	<NAG8\nagx05.h>
///end INCLUDE_OTHER_NAG_HEADER_FILES

#endif //!_O_NAG8_H