 /*-----------------------------------------------------------------------------*
 * File Name: ocgrid.h				 											*
 * Creation: CPY																*
 * Purpose: VC (ogrid) implemented OC functions									*
 * Copyright (c) Originlab Corp.	2007										*
 * All Rights Reserved															*
 * 																				*
 * Modification Log:															*
 *	CPY 12/23/2007 QA80-10625 v8.0775 EXCEL_SHEET_INFO created this file		*
 *	Hong 03/13/08 QA80-11130 OC_NEED_MORE_DETAIL_ERROR_CODE						*
 *	Hong 07/23/08 v8.0907 IMPROVE_IMPORT_EXCEL_ERROR_MESSAGE					*
 *------------------------------------------------------------------------------*/

#ifndef _OC_GRID_H
#define _OC_GRID_H

#ifdef __AFX_H__
	#ifdef _OGRID_DLL
		#define OC_API __declspec(dllexport)
	#else
		#define OC_API __declspec(dllimport)
	#endif
#else
	#define OC_API
#endif//__AFX_H__

//////////////////////////////////////////////
/// exported function prototypes here
//////////////////////////////////////////////
#ifdef __AFX_H__
	#include "OCtoVC.h"
	extern "C" {
#else
	#pragma dll(ogrid.dll)
#endif

//Comments last updated by Hong 03/13/08
// Category last updated by Hong 07/29/08
/**+
http://ocwiki.originlab.com/index.php?title=OriginC:og_get_excel_sheet_names_(global_function)
*/
/// Hong 03/13/08 QA80-11130 OC_NEED_MORE_DETAIL_ERROR_CODE
/// Hong 07/23/08 v8.0907 IMPROVE_IMPORT_EXCEL_ERROR_MESSAGE
/* move to oc_const.h as Worksheet::ImportExcel share the same error value
enum
{
	EXCEL_ERR_UNKNOWN = -20,
	EXCEL_ERR_FILE_NO_FOUND,
	EXCEL_ERR_FILE_ALREADY_EXIST,
	EXCEL_ERR_SHARE_VIOLATION,
};
*/
/// end IMPROVE_IMPORT_EXCEL_ERROR_MESSAGE
/// end OC_NEED_MORE_DETAIL_ERROR_CODE
OC_API int og_get_excel_sheet_names(LPCSTR lpcszFilename, StringArray* psaSheets);
//-----

#ifdef __AFX_H__
	}
#endif	//__AFX_H__
#endif //_OC_GRID_H

